/*
===============================================================================
  MVoiceTest2.c :  MikoVoice ̔mFEBhE\
===============================================================================

	Copyright (C) 2015  Masahiko Watanabe

    Edition History:
	  2015.03.25  

-----------------------------------------------------------------------------*/

//#include  <windows.h>
#include  "MikoVoice.h"


#define  IDM_SAVE			101
#define  IDM_END			102

#define  IDM_SPK_KONCHI		201
#define  IDM_SPK_HAJIME		202
#define  IDM_SPK_IKAGA		203
#define  IDM_SPK_TOKYO		204
#define  IDM_SPK_TONARI		205
#define  IDM_SPK_HAIII		206
#define  IDM_SPK_ATUINA		207

#define  IDM_SNG_OGAWA		301
#define  IDM_SNG_FURUSATO	302
#define  IDM_SNG_HOSHI		303
#define  IDM_SNG_DOREMI		304
#define  IDM_SNG_AOGEBA		305
#define  IDM_SNG_CLOCK2		306
#define  IDM_SNG_SHABON		307
#define  IDM_SNG_HOTARU		308
#define  IDM_SNG_SAKURA		309

#define  IDM_STOP			801
#define  IDM_PAUSE			802
#define  IDM_RESTART		803
#define  IDM_ALL_STOP		804
#define  IDM_ALL_PAUSE		805
#define  IDM_ALL_RESTART	806

#define  IDB_VOICE_OUT		1001	//uv{^hc
#define  IDB_VOICE_PORT		1002	// |[g{^O`V̊_hc

#define  WM_APP_MVO_DONE	0x8801	// o͊bZ[W


LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );

LONG	TextToVoice();
BOOL	SetTextToEditBox( int id );
BOOL	OnPortButtonPushed( int id );
BOOL	VoicePortControl( int id );
LONG	SaveVoiceOutData();

int  iMax( int a, int b )  {  return ( a >= b ) ? a : b ;  }

HWND 	hDlgWnd, hEdtBox, hStcCtl, hOutBtn, hPtBtn[ MVO_MAX_POTRS ];
HGDIOBJ	hDlgFont;
HMENU	hPortMenu;

int		CharXd, CharYd;
int		EdtXo, EdtYo;
int		BtnXd, BtnYd, PtBtnXd, PtBtnYd;
int		ActPortId;
LONG	VoiceOutCount;

//-----------------------------------------------------------------------------

int WINAPI  WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
					 LPSTR szCmdLine, int iCmdShow )
{
	HWND		hWnd;
	MSG			msg;
	WNDCLASSEX	wndclass;
	HMENU		hMainMenu, hSubMenu;
	HDC			hDC;
	TEXTMETRIC	tm;

	wndclass.cbSize        = sizeof( wndclass );
	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = LoadIcon( NULL, IDI_APPLICATION );
	wndclass.hCursor       = LoadCursor( NULL, IDC_ARROW );
	wndclass.hbrBackground = CreateSolidBrush( GetSysColor( COLOR_BTNFACE ) );
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = L"MVoiceTest2";
	wndclass.hIconSm       = LoadIcon( NULL, IDI_APPLICATION );

	RegisterClassEx( &wndclass );

	hMainMenu = CreateMenu();

	hSubMenu = CreateMenu();
	AppendMenu( hSubMenu, MF_STRING, IDM_SAVE, L"ۑ..." );
	AppendMenu( hSubMenu, MF_STRING, IDM_END,  L"I" );

	AppendMenu( hMainMenu, MF_POPUP, (UINT) hSubMenu, L"t@C" );

	hSubMenu = CreateMenu();
	AppendMenu( hSubMenu, MF_STRING, IDM_SPK_KONCHI, L"ɂ" );
	AppendMenu( hSubMenu, MF_STRING, IDM_SPK_HAJIME, L"͂߂܂ĥ" );
	AppendMenu( hSubMenu, MF_STRING, IDM_SPK_IKAGA,  L"łH" );
	AppendMenu( hSubMenu, MF_SEPARATOR, 0, NULL );
	AppendMenu( hSubMenu, MF_STRING, IDM_SPK_TOKYO,  L"" );
	AppendMenu( hSubMenu, MF_STRING, IDM_SPK_TONARI, L"ׂ̋q͗ǂ`Hq" );
	AppendMenu( hSubMenu, MF_SEPARATOR, 0, NULL );
	AppendMenu( hSubMenu, MF_STRING, IDM_SPK_HAIII,  L"͂`H" );
	AppendMenu( hSubMenu, MF_STRING, IDM_SPK_ATUINA, L"͏ȁi֐j" );

	AppendMenu( hMainMenu, MF_POPUP, (UINT)hSubMenu, L"b" );

	hSubMenu = CreateMenu();
	AppendMenu( hSubMenu, MF_STRING, IDM_SNG_OGAWA,   L"t̏" );
	AppendMenu( hSubMenu, MF_STRING, IDM_SNG_FURUSATO,L"ӂ邳" );
	AppendMenu( hSubMenu, MF_STRING, IDM_SNG_HOSHI,   L"̐E" );
	AppendMenu( hSubMenu, MF_SEPARATOR, 0, NULL );
	AppendMenu( hSubMenu, MF_STRING, IDM_SNG_DOREMI,  L"h~\iaj" );
	AppendMenu( hSubMenu, MF_STRING, IDM_SNG_AOGEBA,  L"Αiďj" );
	AppendMenu( hSubMenu, MF_STRING, IDM_SNG_CLOCK2,  L"傫ȌÎviGR[tj" );
	AppendMenu( hSubMenu, MF_STRING, IDM_SNG_SHABON,  L"V{ʁiqj" );
	AppendMenu( hSubMenu, MF_STRING, IDM_SNG_HOTARU,  L"ǔijj" );
	AppendMenu( hSubMenu, MF_STRING, IDM_SNG_SAKURA,  L"炳iru[gtj" );

	AppendMenu( hMainMenu, MF_POPUP, (UINT)hSubMenu, L"̂" );

	hPortMenu = CreatePopupMenu();
	AppendMenu( hPortMenu, MF_STRING, IDM_STOP,    L"~" );
	AppendMenu( hPortMenu, MF_STRING, IDM_PAUSE,   L"x~" );
	AppendMenu( hPortMenu, MF_STRING, IDM_RESTART, L"ĊJ" );
	AppendMenu( hPortMenu, MF_SEPARATOR, 0, NULL );
	AppendMenu( hPortMenu, MF_STRING, IDM_ALL_STOP,    L"SĒ~" );
	AppendMenu( hPortMenu, MF_STRING, IDM_ALL_PAUSE,   L"Sċx~" );
	AppendMenu( hPortMenu, MF_STRING, IDM_ALL_RESTART, L"SčĊJ" );

	hDC = GetDC( NULL );
	hDlgFont = CreateFont(	// {EBhEɕ\镶
		-MulDiv( 10, GetDeviceCaps( hDC, LOGPIXELSY ), 72 ),
		0, 0, 0, FW_DONTCARE, FALSE, FALSE, FALSE, SHIFTJIS_CHARSET,
		OUT_OUTLINE_PRECIS, CLIP_DEFAULT_PRECIS, CLEARTYPE_QUALITY,	FIXED_PITCH,
		L"lr SVbN" );
	SelectObject( hDC, hDlgFont );
	GetTextMetrics( hDC, &tm );
	ReleaseDC( NULL, hDC );
	CharXd = tm.tmAveCharWidth;						// 
	CharYd = tm.tmHeight + tm.tmExternalLeading;	// 
	EdtXo = CharXd * 2;			// GfBbg{bNX̍[ʒu
	EdtYo = CharYd * 11 / 4;	// @@@@ V @@@@[ʒu
	BtnXd = CharXd * 10;		//uv{^̕
	BtnYd = CharYd * 9 / 4;		//@@@ V @@@
	PtBtnXd = CharXd * 7 / 2;	// |[g{^̕
	PtBtnYd = BtnYd * 4 / 5;	// @@@@V@@@@

	hWnd = CreateWindow(
				wndclass.lpszClassName, L"MikoVoice ̔mF",
				WS_OVERLAPPEDWINDOW,
				CW_USEDEFAULT, CW_USEDEFAULT,
				CharXd * 60, CharYd * 28,
				NULL, hMainMenu, hInstance, NULL );

	ShowWindow( hWnd, iCmdShow );
	UpdateWindow( hWnd );

	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}

	DestroyMenu( hPortMenu );
	DeleteObject( hDlgFont );
	DeleteObject( wndclass.hbrBackground );
	UnregisterClass( wndclass.lpszClassName, hInstance );

	return msg.wParam;
}

//-----------------------------------------------------------------------------

LRESULT CALLBACK WndProc( HWND hWnd, UINT iMsg, WPARAM wParam, LPARAM lParam )
{
	int  i;

	switch( iMsg )
	{
	  case WM_CREATE:
		hDlgWnd = hWnd;

		hEdtBox = CreateWindow( L"edit", NULL,
			WS_CHILD | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL |
				WS_BORDER | ES_LEFT | ES_MULTILINE |
				ES_AUTOHSCROLL | ES_AUTOVSCROLL,
			0, 0, 0, 0, hWnd, (HMENU) 1,
			((LPCREATESTRUCT)lParam)->hInstance, NULL );
		SendMessage( hEdtBox, WM_SETFONT, (WPARAM) hDlgFont, FALSE );

		hStcCtl = CreateWindow( L"static", L"LeLXǵF",
			WS_CHILD | WS_VISIBLE | SS_LEFT,
			CharXd * 2, CharYd, CharXd * 30, CharYd + 2,
			hWnd, (HMENU) 2, ((LPCREATESTRUCT)lParam)->hInstance, NULL );
		SendMessage( hStcCtl, WM_SETFONT, (WPARAM) hDlgFont, FALSE );

		hOutBtn = CreateWindow( L"button", L"",
			WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
			0, 0, 0, 0, hWnd, (HMENU) IDB_VOICE_OUT,
			((LPCREATESTRUCT)lParam)->hInstance, NULL );
		SendMessage( hOutBtn, WM_SETFONT, (WPARAM) hDlgFont, FALSE );

		for( i = 0 ; i < MVO_MAX_POTRS ; i++ )
		{
			WCHAR	Name[2];
			Name[0] = L'0' + i;
			Name[1] = 0;
			hPtBtn[i] = CreateWindowEx( 
				WS_EX_STATICEDGE, L"button", Name,
				WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON | WS_DISABLED,
				0, 0, 0, 0, hWnd, (HMENU)( IDB_VOICE_PORT + i ),
				((LPCREATESTRUCT)lParam)->hInstance, NULL );
			SendMessage( hPtBtn[i], WM_SETFONT, (WPARAM) hDlgFont, FALSE );
		}
		return 0;

	  case WM_SETFOCUS:
		SetFocus( hEdtBox );
		return 0;

	  case WM_SIZE:
		{
		  // EBhẼTCYɉāAfBbg{bNXƊe{^zu
			int	EdtXd = iMax( LOWORD( lParam ) - EdtXo * 2, CharXd * 40 );
			int EdtYd = iMax( HIWORD( lParam )
								- ( EdtYo + BtnYd * 2 ), CharYd * 8 );
			int DX = iMax( ( LOWORD( lParam ) 
						- BtnXd - PtBtnXd * MVO_MAX_POTRS )
						/ ( 4 + 4 + 2 * ( MVO_MAX_POTRS - 1 ) + 4 ), 0 );
			int BtnYo = EdtYo + EdtYd + BtnYd / 2;

			MoveWindow( hEdtBox, EdtXo, EdtYo, EdtXd, EdtYd, TRUE );
			MoveWindow( hOutBtn, 4 * DX, BtnYo, BtnXd, BtnYd, TRUE );

			for( i = 0 ; i < MVO_MAX_POTRS ; i++ )
			{
				MoveWindow( hPtBtn[i],
					BtnXd + PtBtnXd * i + DX * ( 4 + 4 + 2*i ),
					BtnYo + PtBtnYd / 5, PtBtnXd, PtBtnYd, TRUE );
			}
		}
		return 0;

	  case WM_COMMAND:
		if( HIWORD( wParam ) == 0 )
		{
			int id = LOWORD( wParam );
			switch( id )
			{
			  case IDM_SAVE:		SaveVoiceOutData();
									break;
			  case IDM_END:			PostMessage( hWnd, WM_CLOSE, 0, 0 );
									break;
			  case IDB_VOICE_OUT:	TextToVoice();
									break;
			  default:
				if( id >= IDM_STOP  &&  id <= IDM_ALL_RESTART )
					VoicePortControl( id );
				else
				if( id >= IDB_VOICE_PORT  &&
					id < IDB_VOICE_PORT + MVO_MAX_POTRS )
					OnPortButtonPushed( id );
				else
					SetTextToEditBox( id );
				break;
			}
		}
		return 0;

	  case WM_APP_MVO_DONE:  // bZ[Wi wParam: |[gԍ j
		// |[gԍɑΉ{^𖳌ɂ
		if( 0 <= wParam  &&  wParam < MVO_MAX_POTRS )
			EnableWindow( hPtBtn[ wParam ], FALSE );
		return 0;

	  case WM_DESTROY:
		MikoVoiceOutStop( -1 );
		PostQuitMessage( 0 );
		return 0;
	}
	return DefWindowProc( hWnd, iMsg, wParam, lParam );
}

//-----------------------------------------------------------------------------

BOOL	OnPortButtonPushed( int id )
{
	POINT	P;
	ActPortId = id - IDB_VOICE_PORT;
	GetCursorPos( &P );
	return TrackPopupMenuEx( hPortMenu,
		TPM_LEFTALIGN | TPM_TOPALIGN | TPM_RIGHTBUTTON,
		P.x, P.y, hDlgWnd, NULL );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

BOOL	VoicePortControl( int id )
{
	LONG	PortBit = 1 << ActPortId;
	int		i;
	switch( id )
	{
	  case IDM_STOP:		MikoVoiceOutStop   ( PortBit );	  break;
	  case IDM_PAUSE:		MikoVoiceOutPause  ( PortBit );	  break;
	  case IDM_RESTART:		MikoVoiceOutRestart( PortBit );	  break;
	  case IDM_ALL_STOP:	MikoVoiceOutStop   ( -1 );		  break;
	  case IDM_ALL_PAUSE:	MikoVoiceOutPause  ( -1 );		  break;
	  case IDM_ALL_RESTART:	MikoVoiceOutRestart( -1 );		  break;
	}

	for( i = 0 ; i < MVO_MAX_POTRS ; i++ )
	{
		switch( MikoVoiceOutGetStat( i ) )
		{
		  case MVO_STAT_PLAYING:
		  case MVO_STAT_PAUSING:
			EnableWindow( hPtBtn[ i ], TRUE );
			break;
		  default:
			EnableWindow( hPtBtn[ i ], FALSE );
			break;
		}
	}
	return 0;
}

//-----------------------------------------------------------------------------

LONG	TextToVoice()
{
	LONG	port;
	WCHAR	TextBuff[ 4*1024 ];

	SendMessage( hEdtBox, WM_GETTEXT,
				 sizeof( TextBuff ) / sizeof( WCHAR ), (LPARAM) TextBuff );
	port = MikoVoiceOutAsync( 
				TextBuff, hDlgWnd, WM_APP_MVO_DONE, ++VoiceOutCount );
	if( 0 <= port  &&  port < MVO_MAX_POTRS )
		EnableWindow( hPtBtn[ port ], TRUE );
	else
		MessageBox( hDlgWnd, L"Ɏs܂I", L"MikoVoice",
				MB_ICONWARNING | MB_OK );
	return port;
}

//-----------------------------------------------------------------------------

BOOL	SetTextToEditBox( int id )
{
	LPCWSTR	text;

	switch( id )
	{
	  case IDM_SPK_KONCHI:
		text = L"[ɂ]\r\n";
		break;

	  case IDM_SPK_HAJIME:
		text = 
		L"*Te320 *Sp0\r\n"
		L"P0 S3.4 [ P1 ߂]āAS3.5\r\n"
		L"P0 S3.5 [ P1 ] S3.5 /\r\n"
		L"P0 S3.4 [ P1 ] s4.3 BP0\r\n";
		break;

	  case IDM_SPK_IKAGA:
		text = L"P1.5 S3 v-1 ^ S4 ł S4 P0 S5 H\r\n";
		break;

	  case IDM_SPK_TOKYO:
		text = 
		L"*Te600 *Sp1\r\n"
		L"^[ P1 ^^[ ^Ƃ傫^^傭 P0\r\n";
		break;

	  case IDM_SPK_TONARI:
		text = 
		L"*Te600 *Sp1\r\n"
		L"P0 ^ P1 ^̂^A\r\n"
		L"P0 ^悭 P1 ^^^ P0\r\n";
		break;

	  case IDM_SPK_HAIII:
		text = 
		L"P1 S4.5  S4.5 P0  S1/8 [[[[[[[[[[[ P3 [[[[[[[ P8\r\n";
		break;

	  case IDM_SPK_ATUINA:
		text = 
		L"!!  ͏Ȃi֐ANZgj\r\n"
		L"P0 [, P-1 P0 ^^ȁ[\r\n";
		break;

	  case IDM_SNG_OGAWA:
		text = 
		L"!! t̏   쎌 CV   \r\n"
		L"*Te110 *Ks0\r\n"
		L"e4  g4 [ a4  g4  e4  g4  +c4  +c4  \r\n"
		L"a4  a4  g4  e4  c4  d4  e4  r4\r\n"
		L"e4  g4 [ a4  g4  e4  g4  +c4  +c4  \r\n"
		L"a4  a4  g4  e4  d4  e4  c4  r4\r\n"
		L"d4  e4 [ d4  g4  a4  a4  g4  a4 \r\n"
		L"+c4  +c4  b4  a4  g4  g4  e4  r4\r\n"
		L"e4  g4 [ a4  g4  e4  g4  +c4  +c4 \r\n"
		L"a4  a4  g4  e4  d4  e4  c4  r4\r\n";
		break;

	  case IDM_SNG_FURUSATO:
		text = 
		L"!! ӂ邳   쎌 CV   \r\n"
		L"*Te80 *Ks1\r\n"
		L"g4  g4  g4  a6  b2  a4  b4  b4  +c4  +d8  r4\r\n"
		L"+c4  +d4  +e4  b6  +c2  b4  a4  a4  f4  g8  r4\r\n"
		L"a2  g2 [ a4  d4  g2  a2 [ b4  b4  \r\n"
		L"+c2  b2 [ +c6  +e2 [ +d2  +c2 [ b4  r4\r\n"
		L"+d4  +d4  +d4  g6  a2  b4  +c4  +c4  a4  g10  r2\r\n";
		break;

	  case IDM_SNG_HOSHI:
		text = 
		L"!! ̐E   쎌 H   `[YER@[X\r\n"
		L"*Te88 *Ks-1\r\n"
		L"+c6  +c2  +d2  +c2  a2  f2  f8  d7  r1\r\n"
		L"c6  f2  a2  f2  +c2  a2  g10  r4 \r\n"
		L"+c6  +c2  +d2  +c2  a2  f2  f8  d7  r1\r\n"
		L"c6  f2  a2  g2  f2  e2  f10  r4 \r\n"
		L"g6  f#2  g2  a2  b2  g2  a8  +c6  r2\r\n"
		L"+d6  +d2  +c2  a2  b2  a2  g12  r4\r\n"
		L"+c6  +c2  +d2  +c2  a2  f2  f8  d6  r2\r\n"
		L"c6  f2  a2  g2  f2  e2  f12  r4\r\n";
		break;

	  case IDM_SNG_DOREMI:
		text = 
		L"!! h~\iaj\r\n"
		L"*Te50 *Ks0\r\n"
		L"*Tr0  c8 h\r\n"
		L"*Tr1  r2    e6 ~\r\n"
		L"*Tr2  r2    r2    g4 \\r\n";
		break;

	  case IDM_SNG_AOGEBA:
		text = 
		L"!! Αiďj 쎌EȎҕs\r\n"
		L"*Te80 *Ks-3\r\n"
		L"*Tr0 V0 P0\r\n"
		L"@g2  g4  a2  b4  b2  +c4  +c2  b4  \r\n"
		L"@g2  f4  g2  a4  +c2  b8  r2\r\n"
		L"@g2  g4  a2  b4  b2  +c4  +c2  b4  \r\n"
		L"@g2  f4  +c2  b4  d2  e8  r2\r\n"
		L"@e2  +c4  +c2  a4  +c2  b4  g2  b4  \r\n"
		L"@b2  +c4  +e2  +d4  +c2  b9  r1\r\n"
		L"@a2  g4  a2  b4  +e2  +e4  +c2  +c6  r2\r\n"
		L"@a2  f4  a2  g4  f2 [ e10 \r\n"
		L"*Tr1 V-2 P0.1\r\n"
		L"@g2  g4  a2  b4  b2  +c4  +c2  b4  \r\n"
		L"@g2  f4  g2  a4  +c2  b8  r2\r\n"
		L"@g2  g4  a2  b4  b2  +c4  +c2  b4  \r\n"
		L"@g2  f4  +c2  b4  d2  e8  r2\r\n"
		L"@e2  +c4  +c2  a4  +c2  b4  g2  b4  \r\n"
		L"@b2  +c4  +e2  +d4  +c2  b9  r1\r\n"
		L"@a2  g4  a2  b4  +e2  +e4  +c2  +c6  r2\r\n"
		L"@a2  f4  a2  g4  f2 [ e10 \r\n";
		break;

	  case IDM_SNG_CLOCK2:
		text = 
		L"!!  傫ȌÎviGR[tj  ەxM   [N\r\n"
		L"*Ks+1 *Te120\r\n"
		L"*Tr0 V+1\r\n"
		L"@d4  g4  f2  g2  a2  a2  g2  a2  \r\n"
		L"@b2  b2  +c2  b2  e4 \r\n"
		L"@a2  a2  g4  g2  g2  f4  e2  f2  g10  r2\r\n"
		L"*Tr1 V-1 r1.2\r\n"
		L"@d4  g4  f2  g2  a2  a2  g2  a2  \r\n"
		L"@b2  b2  +c2  b2  e4 \r\n"
		L"@a2  a2  g4  g2  g2  f4  e2  f2  g10  r2\r\n";
		break;

	  case IDM_SNG_SHABON:
		text = 
		L"!! V{ʁiqj 쎌 J   RW\r\n"
		L"*Pg+4.5 *Te60 *Ks-3\r\n"
		L"-b2  e1  e1  e2  f2  g2  b2  b2  r2\r\n"
		L"+c2  a2  +e2  +c2  b2  +c2  b2  r2\r\n"
		L"g2  g2  f2  e2  f2  b2  b2  r2\r\n"
		L"+c2  +c2  b2  e2  g2  f2  e2  r2\r\n"
		L"+e3  +e1  +e2  +e2  +e2  +c2  b2  r2\r\n"
		L"e2  f1  f1  g2  b2  g2  f2  e2  r2\r\n";
		break;

	  case IDM_SNG_HOTARU:
		text = 
		L"!! ǔijj 쎌 _n  XRbghw\r\n"
		L"*Pg-8 *Te100 *Ks+1\r\n"
		L"d4  g6  g2  g4  b4  a6  g2 [ a4  b4  g4  g4  b4  +d4 [ +e12 \r\n"
		L"+e4  +d6  b2  b4  g4  a6  g2 [ a4  b4  g6  e2  e4  d4 [ g8  r4\r\n"
		L"+e4  +d6  b2  b4  g4  a6  g2 [ a4  +e4  +d6  b2 [ b4  +d4  +e12 \r\n"
		L"+e4  +d6  b2  b4  g4  a6  g2 [ a4  b4  g6  e2  e4  d4 [ g8 \r\n";
		break;

	  case IDM_SNG_SAKURA:
		text = 
		L"!! 炳iru[gtj {×w\r\n"
		L"*Te72 *Ks0 *Vf5.5\r\n"
		L"a4  a4  b8  a4  a4  b8  \r\n"
		L"a4  b4  +c4  b4  a4  b2  a2 [ f8  \r\n"
		L"e4  c4  e4  f4  e4  e2  c2 [ -b8 \r\n"
		L"a4  b4  +c4  b4  a4  b2  a2 [ f8 \r\n"
		L"e4  c4  e4  f4  e4  e2  c2 [& -b8 \r\n"
		L"a4  a4  b8  a4  a4  b8 \r\n"
		L"e4  f4  b2  a2 [ f4  e12  r4\r\n";
		break;

	  default:
		return FALSE;
	}

	SendMessage( hEdtBox, WM_SETTEXT, 0, (LPARAM) text );
	return TRUE;
}

//-----------------------------------------------------------------------------

#pragma pack(1)

typedef struct	// wav t@C̃wb_[
{
	DWORD	cRiffId;			// Riff chunk id ( = 'RIFF' )
	DWORD	nRiffSiz;			// Riff chunk size ( = <file size> - 8 )
	DWORD	cWaveId;			// = 'WAVE'
	DWORD	cFormatId;			// format chunk id ( = 'fmt ' )
	DWORD	nFormatSize;		// format chunck size ( = 16 )
	WORD	wFormatTag;			// format tag ( =1: PCM )
	WORD	nChannels;			// number of channels ( =1: mono, =2: stereo )
	DWORD	nSamplesPerSec;		// sampling rate [Hz]
	DWORD	nAvgBytesPerSec;	// average data-transfer rate in bytes per second
	WORD	nBlockAlign;		// = nChannels * nBitsPerSample / 8 
	WORD	wBitsPerSample;		// # of bits of sampling data
	DWORD	cDataId;			// data chunk id ( = 'data' )
	DWORD	nDataSize;			// data chunk size
	//							// sampled PCM data area
}
WAVEFILEHEADER;

#define  CHAR4( c1,c2,c3,c4 )  (DWORD)(( c4 << 24 ) + ( c3 << 16 ) + ( c2 << 8 ) + c1 )


HANDLE	hFile;	// f[^ރt@C̃nh


// f[^t@CɏރR[obN֐

BOOL  CALLBACK	WavRecFnc( LPCVOID bp, LONG bn )
{
	DWORD	wn;
	if( WriteFile( hFile, bp, bn, &wn, NULL )  &&  bn == wn )
		return TRUE;
	else
		return FALSE;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

// LeLXg特g`f[^t@Cɏ

LONG	SaveVoiceOutData()
{
	OPENFILENAME	ofn;
	WCHAR			FileName[ MAX_PATH ];
	static WCHAR	InitPath[ MAX_PATH ];
	WAVEFILEHEADER	wfh;
	LONG			Bn, Wn;
	WCHAR			TextBuff[ 4*1024 ];

  //iPjۑ̃t@C擾

	memset( &ofn, 0, sizeof( OPENFILENAME ) );
	FileName[0] = 0;
	if( InitPath[0] == 0 )
		GetCurrentDirectory( MAX_PATH, InitPath );

	ofn.lStructSize = sizeof( OPENFILENAME );
	ofn.hwndOwner = hDlgWnd;
	ofn.lpstrFilter = 
		L"t@C(*.wav)\0*.wav\0"
		L"S(*.*)\0*.*\0";
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = FileName;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrInitialDir	= InitPath;
	ofn.lpstrTitle = L"̕ۑt@C";
	ofn.Flags = OFN_OVERWRITEPROMPT
			  | OFN_HIDEREADONLY
			  | OFN_NOCHANGEDIR
			  | OFN_ENABLESIZING
			  | OFN_PATHMUSTEXIST;
	ofn.lpstrDefExt = L"wav";

	if( GetSaveFileName( &ofn ) <= 0 )
	{
		//DWORD ev = CommDlgExtendedError();
		return -1;
	}

	memcpy( InitPath, FileName, ofn.nFileOffset * sizeof( WCHAR ) );
	InitPath[ ofn.nFileOffset ] = 0;

  //iQjw肳ꂽt@C։g`f[^

	// wt@CJ
	hFile = CreateFile( FileName, GENERIC_WRITE, 0, NULL,
				CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
	if( hFile == INVALID_HANDLE_VALUE )
		goto FILE_ERROR;

	// wb_[΂i͌ŏށj
	if( SetFilePointer( hFile, sizeof( wfh ), NULL, FILE_BEGIN )
			== INVALID_SET_FILE_POINTER )
		goto FILE_ERROR;

	// LeLXgGfBbg{bNXo
	SendMessage( hEdtBox, WM_GETTEXT,
			 sizeof( TextBuff ) / sizeof( WCHAR ), (LPARAM) TextBuff );

	// g`f[^t@Cɏ
	Bn = MikoVoiceOutToBuf( TextBuff, WavRecFnc );	// Ԓl: g`f[^TCY
	if( Bn < 0 )
		goto FILE_ERROR;

	// t@C̐擪ɖ߂āAwb_[
	if( SetFilePointer( hFile, 0, NULL, FILE_BEGIN )
			== INVALID_SET_FILE_POINTER )
		goto FILE_ERROR;

	wfh.cRiffId         = CHAR4( 'R','I','F','F' );
	wfh.nRiffSiz        = sizeof( wfh ) + Bn - 8;
	wfh.cWaveId         = CHAR4( 'W','A','V','E' );
	wfh.cFormatId       = CHAR4( 'f','m','t',' ' );
	wfh.nFormatSize     = 16;
	wfh.wFormatTag      = WAVE_FORMAT_PCM;	// = 1
	wfh.nChannels       = MVO_WAVE_CHANS;
	wfh.nSamplesPerSec  = MVO_WAVE_FREQ;
	wfh.nAvgBytesPerSec = MVO_WAVE_FREQ * MVO_WAVE_BITS / 8 * MVO_WAVE_CHANS;
	wfh.nBlockAlign     = MVO_WAVE_BITS / 8 * MVO_WAVE_CHANS;
	wfh.wBitsPerSample  = MVO_WAVE_BITS;
	wfh.cDataId         = CHAR4( 'd','a','t','a' );
	wfh.nDataSize       = Bn;

	if( WriteFile( hFile, &wfh, sizeof( wfh ), &Wn, NULL ) == FALSE )
		goto FILE_ERROR;

	CloseHandle( hFile );
	return Bn;	// Ԓl: ꂽg`f[^̃TCYioCgj

  FILE_ERROR:
	FormatMessage( FORMAT_MESSAGE_FROM_SYSTEM, NULL,
		GetLastError(), LANG_SYSTEM_DEFAULT,
		TextBuff, sizeof( TextBuff ) / sizeof( WCHAR ), NULL );
	MessageBox( hDlgWnd, TextBuff, &FileName[ ofn.nFileOffset ], MB_OK );
	return -1;	// Ԓl: G[
}

//-----------------------------------------------------------------------------

